<template>
    <div>
        <HomeComponent v-if="show==='homeComponent'"></HomeComponent>
        <SingleProduct :currentUser="currentUser" v-else-if="show==='singleProduct'" :product="product"></SingleProduct>
        <CategorySearch v-else-if="show==='categorySearch'" :products="products"></CategorySearch>
        <CartMain v-else-if="show==='cartMain'"></CartMain>
        <AboutUs v-else-if="show==='aboutUs'"></AboutUs>

<!--        <router-view></router-view>-->
        <CartSidebar></CartSidebar>
        <QuickView></QuickView>
    </div>
</template>

<script>
    import HomeComponent from "./HomeComponent";
    import CartMain from "./CartMain";
    import CartSidebar from "./CartSidebar";
    import SingleProduct from "./SingleProduct";
    import CategorySearch from "./CategorySearch";
    import QuickView from "./QuickView";
    import AboutUs from "./AboutUs";
    import {EventBus} from "./event-bus";
    import Toaster from 'v-toaster'
    import 'v-toaster/dist/v-toaster.css';
    Vue.use(Toaster, {timeout: 3000});
    export default {
        props: {
            currentUser: {
                type: Object,
                required: true
            }
        },
        created(){
            EventBus.$on('singleProduct', payload => {
                this.product=payload;
                this.show='singleProduct';
            });
            EventBus.$on('pageLoader', payload => {
                this.show=payload;
            });
            EventBus.$on('categoryLoader', payload => {
                this.show='categorySearch';
                this.info = payload;
            });
        },
        data(){
            return{
                show:'homeComponent',
                product:{},//single product info are store here
                info:{},//category wise search info are store here
            }
        },
        components:{HomeComponent,SingleProduct,CartSidebar,CategorySearch,QuickView,CartMain,AboutUs},
        computed:{
            products(){
                return this.$store.getters.products.filter((item)=>{
                    if(this.info.status ==0 && item.category_id===this.info.category && item.sub_category_id === this.info.sub_category){
                        return item;
                    }else if(this.info.status ==1 && item.sub_category_id===this.info.category && item.sub_sub_category_id === this.info.sub_category){
                        return item;
                    }
                });
            }
        }
    }
</script>
